using System;
using System.Collections.Generic;
using UnityEngine;

namespace CarMod
{
	public class CarMod : MonoBehaviour
	{
		public static void Main()
		{

		//Category	
		//CategoryBuilder.Create("Tankos", "By PaulRiisk", ModAPI.LoadSprite("Tank_Collection_Thumb.png"));

		ModAPI.Register(
	 new Modification()
	 {
		OriginalItem = ModAPI.FindSpawnable("Tank"),
		NameOverride = "Tiger I",
		NameToOrderByOverride = "!",
		DescriptionOverride = "The Tiger I is arguably the most famous tank of the Second World War.",
		CategoryOverride = ModAPI.FindCategory("Vehicles"),
		ThumbnailOverride = ModAPI.LoadSprite("Textures/Thumb.png"),
		AfterSpawn = (Instance) =>
		{
		    

			//Main Parts
			Destroy(Instance.GetComponentInChildren<RandomCarTextureBehaviour>());
			Instance.transform.Find("Body").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                               	{
                                    ModAPI.LoadSprite("Textures/Body_neu.png"),	
                                };
								
			Instance.transform.Find("Head").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                               	{
                                    ModAPI.LoadSprite("Textures/Head_neu.png"),
                                };	
												
			Instance.transform.Find("Barrel").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	        	{
                                    ModAPI.LoadSprite("Textures/Barrel.png"),
                                };				

			Instance.transform.Find("Gas tank").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	        	{
                                    ModAPI.LoadSprite("Textures/Gastank.png"),
                                };	

			Instance.transform.Find("Engine").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	        	{
                                    ModAPI.LoadSprite("Textures/Engine.png"),
                                };	

			//Wheels
			Instance.transform.Find("Wheel").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel1.png"),
                                };

			Instance.transform.Find("Wheel (1)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
               	                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			Instance.transform.Find("Wheel (2)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			Instance.transform.Find("Wheel (3)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			Instance.transform.Find("Wheel (4)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };
			
		    Instance.transform.Find("Wheel (5)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			Instance.transform.Find("Wheel (6)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			Instance.transform.Find("Wheel (7)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			Instance.transform.Find("Wheel (8)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel1.png"),
                                };
			  
			   }
		  }
	    );

		//Tank Mounts
		ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "A Tankmount for Tiger I - 1",
                    NameToOrderByOverride = "A Tankmount for Tiger I - 1",
                    DescriptionOverride = "This is a Gun Mount for the Tiger I.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Mount1Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mount1.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 13f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.FixColliders();
                    }
                }
			);

		ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "A Tankmount for Tiger I - 2",
                    NameToOrderByOverride = "A Tankmount for Tiger I - 2",
                    DescriptionOverride = "This is a Gun Mount for the Tiger I.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Mount2Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mount2.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 13f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.FixColliders();
                    }
                }
			);


		}
	}
	     
}
    

