using System;
using System.Collections.Generic;
using UnityEngine;

namespace CarMod
{
	public class CarMod : MonoBehaviour
	{
		public static void Main()
		{

		//Category	
		//CategoryBuilder.Create("Tankos", "By PaulRiisk", ModAPI.LoadSprite("Tank_Collection_Thumb.png"));

		ModAPI.Register(
	 new Modification()
	        {
		        OriginalItem = ModAPI.FindSpawnable("Tank"),
		        NameOverride = "Tiger I",
		        NameToOrderByOverride = "!",
		        DescriptionOverride = "The Tiger I is arguably the most famous tank of the Second World War.",
		        CategoryOverride = ModAPI.FindCategory("Vehicles"),
		        ThumbnailOverride = ModAPI.LoadSprite("Textures/Thumb.png"),
		        AfterSpawn = (Instance) =>
		        {
			    //Main
                    Destroy(Instance.GetComponentInChildren<RandomCarTextureBehaviour>());
                    var TankHead = Instance.transform.Find("Head");
                    var TankBody = Instance.transform.Find("Body"); 
                    var TankBarrel = Instance.transform.Find("Barrel"); 
                    var TankGasTank = Instance.transform.Find("Gas tank"); 
                    var TankEngine = Instance.transform.Find("Engine"); 

                    var TankSettings = TankBody.GetComponent<CarBehaviour>();
                    TankSettings.MotorSpeed = -500f;
                    TankSettings.WaterProof = false;
                    
                    var BarrelSettings = TankBarrel.GetComponent<TankBarrelBehaviour>();
                    BarrelSettings.RecoilIntensity = 15f;
                    BarrelSettings.barrelPosition = new Vector2(3.67f, 0f);
                    BarrelSettings.barrelDirection = new Vector2(1, 0);

                //DestroyColliders
                    BoxCollider2D[] boxColliders = TankHead.GetComponents<BoxCollider2D>();
                    GameObject.Destroy(boxColliders[0]);
                    GameObject.Destroy(boxColliders[1]);
                    GameObject.Destroy(boxColliders[2]);

                    BoxCollider2D[] boxColliders2 = TankBody.GetComponents<BoxCollider2D>();
                    GameObject.Destroy(boxColliders2[0]);
                    GameObject.Destroy(boxColliders2[1]);
                    GameObject.Destroy(boxColliders2[2]);
                    GameObject.Destroy(boxColliders2[3]);
                    GameObject.Destroy(boxColliders2[4]);

                    BoxCollider2D[] boxColliders3 = TankBarrel.GetComponents<BoxCollider2D>();
                    GameObject.Destroy(boxColliders3[0]);

                //Tank Head
			        TankHead.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                        ModAPI.LoadSprite("Textures/Head_neu.png"),
                    };
                    PolygonCollider2D TankHeadColl = TankHead.GetComponent<PolygonCollider2D>();
                    TankHeadColl.pathCount = 1;
                    TankHeadColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(2.36352706f,0.177942127f),
                        new Vector2(1.51945329f,0.310899168f),
                        new Vector2(1.00607896f,0.313114405f),
                        new Vector2(0.939625263f,0.570436001f),
                        new Vector2(0.196178809f,0.571863234f),
                        new Vector2(0.137472451f,0.309770316f),
                        new Vector2(-0.902909279f,0.316301823f),
                        new Vector2(-0.905296445f,0.826096177f),
                        new Vector2(-1.023839f,0.823621392f),
                        new Vector2(-1.02987587f,0.314720362f),
                        new Vector2(-1.33273697f,0.311983109f),
                        new Vector2(-2.22383809f,0.109552756f),
                        new Vector2(-2.22878861f,-0.454885185f),
                        new Vector2(-1.65109539f,-0.455247402f),
                        new Vector2(-0.957231164f,-0.826096177f),
                        new Vector2(2.48367405f,-0.8310467f),
                        new Vector2(2.64272785f,-0.697872102f),
                        new Vector2(2.73812413f,-0.383109272f),
                        new Vector2(2.62179828f,0.0477194041f)
                    });
                //Body	
					TankBody.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                        ModAPI.LoadSprite("Textures/Body_neu.png"),	
                    };
                    PolygonCollider2D TankBodydColl = TankBody.gameObject.AddComponent<PolygonCollider2D>();
                    TankBodydColl.pathCount = 1;
                    TankBodydColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(4.74023056f,0.0684381053f),
                        new Vector2(4.21054125f,0.0498948246f),
                        new Vector2(4.28302431f,0.160068274f),
                        new Vector2(4.09485674f,0.183271408f),
                        new Vector2(4.09404993f,0.258016825f),
                        new Vector2(4.41752148f,0.346821636f),
                        new Vector2(4.39968491f,0.450469255f),
                        new Vector2(4.03872871f,0.393738508f),
                        new Vector2(3.96800089f,0.502992392f),
                        new Vector2(3.55752087f,0.546719074f),
                        new Vector2(3.55472684f,0.632377505f),
                        new Vector2(3.3005085f,0.629113197f),
                        new Vector2(3.30089903f,0.544699669f),
                        new Vector2(3.2210784f,0.539460897f),
                        new Vector2(3.18300962f,0.633625031f),
                        new Vector2(2.43523121f,0.636134386f),
                        new Vector2(2.41636181f,0.544475794f),
                        new Vector2(2.21671915f,0.543881416f),
                        new Vector2(2.21623182f,0.658230066f),
                        new Vector2(-1.1792506f,0.648263633f),
                        new Vector2(-1.1761179f,0.538210392f),
                        new Vector2(-1.97498226f,0.540175438f),
                        new Vector2(-2.10018253f,0.672969341f),
                        new Vector2(-2.31750679f,0.676953793f),
                        new Vector2(-2.49043941f,0.806347847f),
                        new Vector2(-2.66925621f,0.820570946f),
                        new Vector2(-2.85154247f,0.68721962f),
                        new Vector2(-4.43672752f,0.697429895f),
                        new Vector2(-4.46330738f,0.797902107f),
                        new Vector2(-5.12506771f,0.794080198f),
                        new Vector2(-4.9994874f,-0.499241233f),
                        new Vector2(-4.5752039f,-0.498943269f),
                        new Vector2(-4.31661701f,-0.239033699f),
                        new Vector2(-3.98746204f,-0.563457966f),
                        new Vector2(-2.67291355f,-0.571733475f),
                        new Vector2(-0.0282999575f,-0.540984809f),
                        new Vector2(2.55467033f,-0.511869729f),
                        new Vector2(3.86458397f,-0.486684084f),
                        new Vector2(3.94977427f,-0.294503927f),
                        new Vector2(4.97224426f,-0.465780973f),
                        new Vector2(5.15013599f,-0.154213995f)
                    });
                //Barrel							
			        TankBarrel.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	{
                        ModAPI.LoadSprite("Textures/Barrel.png"),
                    };
                    PolygonCollider2D TankBarrelColl = TankBarrel.gameObject.AddComponent<PolygonCollider2D>();
                    TankBarrelColl.pathCount = 1;
                    TankBarrelColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(3.62576246f,-0.127690956f),
                        new Vector2(3.63418913f,0.12351954f),
                        new Vector2(3.45000005f,0.189796925f),
                        new Vector2(3.16493058f,0.191415727f),
                        new Vector2(2.83858252f,0.103893757f),
                        new Vector2(-0.633120537f,0.127360821f),
                        new Vector2(-1.67028236f,0.185359955f),
                        new Vector2(-1.75013351f,0.269302845f),
                        new Vector2(-2.60041332f,0.273690224f),
                        new Vector2(-2.74391842f,0.455055237f),
                        new Vector2(-2.98942757f,0.497460365f),
                        new Vector2(-3.08032393f,0.321477413f),
                        new Vector2(-3.62857151f,0.319205999f),
                        new Vector2(-3.62507057f,-0.326774657f),
                        new Vector2(-3.07341671f,-0.328478813f),
                        new Vector2(-2.99736881f,-0.500908375f),
                        new Vector2(-2.74299526f,-0.45832634f),
                        new Vector2(-2.6045332f,-0.284153938f),
                        new Vector2(-1.75224495f,-0.277493954f),
                        new Vector2(-1.68013883f,-0.198962688f),
                        new Vector2(-0.641166687f,-0.139271736f),
                        new Vector2(2.84246683f,-0.0982136726f),
                        new Vector2(3.14468098f,-0.184714794f),
                        new Vector2(3.56660724f,-0.188607156f)
                    });				
                //Gas Tank
			        Instance.transform.Find("Gas tank").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	{
                        ModAPI.LoadSprite("Textures/Gastank.png"),
                    };	
                //Engine
			        Instance.transform.Find("Engine").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	{
                        ModAPI.LoadSprite("Textures/Engine.png"),
                    };	
			    //Wheels
			            Instance.transform.Find("Wheel").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel1.png"),
                                };

			            Instance.transform.Find("Wheel (1)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
               	                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (2)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (3)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (4)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };
			
		                Instance.transform.Find("Wheel (5)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (6)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (7)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                        };

			            Instance.transform.Find("Wheel (8)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/Wheel1.png"),
                        };
                //Other
                    Instance.AddComponent<NoChildrenCollide>();
                    NoCollide noCollide = Instance.AddComponent<NoCollide>();
                    noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                    noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                //
			        }
		        }
	    );

		//Tank Mounts
		ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "A Tankmount for Tiger I - 1",
                    NameToOrderByOverride = "A Tankmount for Tiger I - 1",
                    DescriptionOverride = "This is a Gun Mount for the Tiger I.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Mount1Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mount1.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 13f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.FixColliders();
                    }
                }
			);

		ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "A Tankmount for Tiger I - 2",
                    NameToOrderByOverride = "A Tankmount for Tiger I - 2",
                    DescriptionOverride = "This is a Gun Mount for the Tiger I.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Mount2Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mount2.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 13f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.FixColliders();
                    }
                }
			);


		}
	}
	     
}
    

